#include <iostream>
#include <chrono>
#include <cmath>
#include <fstream>
#include <numeric>
#include <sstream>
#include <string>
#include <cstring>
#include <vector>
#include "Utils_eigne.h"
#include "fcos_parameters.h"
#include "/usr/local/mdc_sdk_llvm/dp_gea/mdc_cross_compiler/sysroot/usr/include/opencv4/opencv2/imgcodecs.hpp"
#include "/usr/local/mdc_sdk_llvm/dp_gea/mdc_cross_compiler/sysroot/usr/include/opencv4/opencv2/imgproc.hpp"
// ========================= Defines ================== //
using namespace std;


class FCos3dPreProcessor {
public:
    FCos3dPreProcessor(const Fcos3dConstantParameter &init_params)
    {
        this->imageMat = cv::Mat(init_params.height, init_params.width, CV_32FC(init_params.channel));
    };

    ~FCos3dPreProcessor() = default;

    bool Init(const Fcos3dConstantParameter &init_params);

    Vec3D<float> Process(vector<uchar> *imageVectorPtr);
    std::vector<uchar> *matToVectorPointer(const cv::Mat &mat);
    cv::Mat vectorPointerToMat(const std::vector<uchar> *vec, int rows, int cols);
    Vec3D<float> image_vector_without_padding(cv::Mat img);
    Vec3D<float> image_vector_without_padding_channel_last(cv::Mat img);

    Fcos3dPreProcessParameter<float> get_param(){
        return fcos3DPreProcessParameter;
    }

private:
    cv::Mat imageMat;
    Vec3D<int> imageVector;
    Fcos3dPreProcessParameter<float> fcos3DPreProcessParameter;

};

